From 8dbd82be3052be34facd02931a1e7522c0773425 Mon Sep 17 00:00:00 2001
From: Mikhail Golenkov <mikhailgolenkov@catalyst-au.net>
Date: Fri, 3 Jul 2020 14:37:55 +1000
Subject: [PATCH 14/15] MDL-42616 filelib: New user interface to edit and add
 file types (2/2)

New admin tool tool_filetypes which uses the new API to add and modify file type definitions.
---
 admin/tool/filetypes/classes/utils.php        | 122 ++++++++++++
 admin/tool/filetypes/delete.php               |  60 ++++++
 admin/tool/filetypes/edit.php                 | 111 +++++++++++
 admin/tool/filetypes/edit_form.php            | 115 +++++++++++
 admin/tool/filetypes/index.php                |  48 +++++
 .../tool/filetypes/lang/en/tool_filetypes.php |  69 +++++++
 admin/tool/filetypes/renderer.php             | 179 ++++++++++++++++++
 admin/tool/filetypes/revert.php               |  60 ++++++
 admin/tool/filetypes/settings.php             |  31 +++
 admin/tool/filetypes/styles.css               |  32 ++++
 .../tests/behat/add_filetypes.feature         | 107 +++++++++++
 .../tool/filetypes/tests/fixtures/frog-24.png | Bin 0 -> 67 bytes
 .../tool/filetypes/tests/fixtures/frog-48.png | Bin 0 -> 67 bytes
 admin/tool/filetypes/tests/fixtures/test.frog |   1 +
 .../tool/filetypes/tests/fixtures/zombie.gif  | Bin 0 -> 43 bytes
 .../filetypes/tests/tool_filetypes_test.php   |  86 +++++++++
 admin/tool/filetypes/version.php              |  29 +++
 17 files changed, 1050 insertions(+)
 create mode 100644 admin/tool/filetypes/classes/utils.php
 create mode 100644 admin/tool/filetypes/delete.php
 create mode 100644 admin/tool/filetypes/edit.php
 create mode 100644 admin/tool/filetypes/edit_form.php
 create mode 100644 admin/tool/filetypes/index.php
 create mode 100644 admin/tool/filetypes/lang/en/tool_filetypes.php
 create mode 100644 admin/tool/filetypes/renderer.php
 create mode 100644 admin/tool/filetypes/revert.php
 create mode 100644 admin/tool/filetypes/settings.php
 create mode 100644 admin/tool/filetypes/styles.css
 create mode 100644 admin/tool/filetypes/tests/behat/add_filetypes.feature
 create mode 100644 admin/tool/filetypes/tests/fixtures/frog-24.png
 create mode 100644 admin/tool/filetypes/tests/fixtures/frog-48.png
 create mode 100644 admin/tool/filetypes/tests/fixtures/test.frog
 create mode 100644 admin/tool/filetypes/tests/fixtures/zombie.gif
 create mode 100644 admin/tool/filetypes/tests/tool_filetypes_test.php
 create mode 100644 admin/tool/filetypes/version.php

diff --git a/admin/tool/filetypes/classes/utils.php b/admin/tool/filetypes/classes/utils.php
new file mode 100644
index 00000000000..45a1c6b2790
--- /dev/null
+++ b/admin/tool/filetypes/classes/utils.php
@@ -0,0 +1,122 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Class with static back-end methods used by the file type tool.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+namespace tool_filetypes;
+
+defined('MOODLE_INTERNAL') || die();
+
+/**
+ * Class with static back-end methods used by the file type tool.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class utils {
+    /**
+     * Checks if the given file type extension is invalid.
+     * The added file type extension must be unique and must not begin with a dot.
+     *
+     * @param string $extension Extension of the file type to add
+     * @param string $oldextension Extension prior to update (empty string if adding new type)
+     * @return bool True if it the file type trying to add already exists
+     */
+    public static function is_extension_invalid($extension, $oldextension = '') {
+        $extension = trim($extension);
+        if ($extension === '' || $extension[0] === '.') {
+            return true;
+        }
+
+        $mimeinfo = get_mimetypes_array();
+        if ($oldextension !== '') {
+            unset($mimeinfo[$oldextension]);
+        }
+
+        return array_key_exists($extension, $mimeinfo);
+    }
+
+    /**
+     * Checks if we are allowed to turn on the 'default icon' option. You can
+     * only have one of these for a given MIME type.
+     *
+     * @param string $mimetype MIME type
+     * @param string $oldextension File extension name (before any change)
+     */
+    public static function is_defaulticon_allowed($mimetype, $oldextension = '') {
+        $mimeinfo = get_mimetypes_array();
+        if ($oldextension !== '') {
+            unset($mimeinfo[$oldextension]);
+        }
+        foreach ($mimeinfo as $extension => $values) {
+            if ($values['type'] !== $mimetype) {
+                continue;
+            }
+            if (!empty($values['defaulticon'])) {
+                return false;
+            }
+        }
+        return true;
+    }
+
+    /**
+     * Gets all unique file type icons from a specific path, not including
+     * sub-directories.
+     *
+     * Icon files such as pdf.png, pdf-24.png and pdf-36.png etc. are counted as
+     * the same icon type.
+     *
+     * The resultant array has both key and value set to the icon name prefix,
+     * such as 'pdf' => 'pdf'.
+     *
+     * @param string $path The path of the icon path
+     * @return array An array of unique file icons within the given path
+     */
+    public static function get_icons_from_path($path) {
+        $icons = array();
+        if ($handle = @opendir($path)) {
+            while (($file = readdir($handle)) !== false) {
+                $matches = array();
+                if (preg_match('~(.+?)(?:-24|-32|-48|-64|-72|-80|-96|-128|-256)?\.(?:gif|png)$~',
+                        $file, $matches)) {
+                    $key = $matches[1];
+                    $icons[$key] = $key;
+                }
+            }
+            closedir($handle);
+        }
+        ksort($icons);
+        return $icons;
+    }
+
+    /**
+     * Gets unique file type icons from pix/f folder.
+     *
+     * @return array An array of unique file type icons e.g. 'pdf' => 'pdf'
+     */
+    public static function get_file_icons() {
+        global $CFG;
+        $path = $CFG->dirroot . '/pix/f';
+        return self::get_icons_from_path($path);
+    }
+}
diff --git a/admin/tool/filetypes/delete.php b/admin/tool/filetypes/delete.php
new file mode 100644
index 00000000000..8b73f2bceab
--- /dev/null
+++ b/admin/tool/filetypes/delete.php
@@ -0,0 +1,60 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Delete a file type with a confirmation box.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require(__DIR__ . '/../../../config.php');
+require_once($CFG->libdir . '/adminlib.php');
+
+admin_externalpage_setup('tool_filetypes');
+
+$extension = required_param('extension', PARAM_ALPHANUMEXT);
+$redirecturl = new \moodle_url('/admin/tool/filetypes/index.php');
+
+if (optional_param('delete', 0, PARAM_INT)) {
+    require_sesskey();
+
+    // Delete the file type from the config.
+    core_filetypes::delete_type($extension);
+    redirect($redirecturl);
+}
+
+// Page settings.
+$title = get_string('deletefiletypes', 'tool_filetypes');
+
+$context = context_system::instance();
+$PAGE->set_url(new \moodle_url('/admin/tool/filetypes/delete.php', array('extension' => $extension)));
+$PAGE->navbar->add($title);
+$PAGE->set_context($context);
+$PAGE->set_pagelayout('admin');
+$PAGE->set_title($SITE->fullname. ': ' . $title);
+
+// Display the page.
+echo $OUTPUT->header();
+
+$message = get_string('delete_confirmation', 'tool_filetypes', $extension);
+$deleteurl = new \moodle_url('delete.php', array('extension' => $extension, 'delete' => 1));
+$yesbutton = new single_button($deleteurl, get_string('yes'));
+$nobutton = new single_button($redirecturl, get_string('no'), 'get');
+echo $OUTPUT->confirm($message, $yesbutton, $nobutton);
+
+echo $OUTPUT->footer();
diff --git a/admin/tool/filetypes/edit.php b/admin/tool/filetypes/edit.php
new file mode 100644
index 00000000000..33d934bee1d
--- /dev/null
+++ b/admin/tool/filetypes/edit.php
@@ -0,0 +1,111 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Display the file type updating page.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require(__DIR__ . '/../../../config.php');
+require_once($CFG->libdir . '/adminlib.php');
+require_once('edit_form.php');
+
+admin_externalpage_setup('tool_filetypes');
+
+$oldextension = optional_param('oldextension', '', PARAM_ALPHANUMEXT);
+$mform = new tool_filetypes_form('edit.php', array('oldextension' => $oldextension));
+$title = get_string('addfiletypes', 'tool_filetypes');
+
+if ($oldextension) {
+    // This is editing an existing filetype, load data to the form.
+    $mimetypes = get_mimetypes_array();
+    if (!array_key_exists($oldextension, $mimetypes)) {
+        throw new moodle_exception('error_notfound', 'tool_filetypes');
+    }
+    $typeinfo = $mimetypes[$oldextension];
+    $formdata = array(
+        'extension' => $oldextension,
+        'mimetype' => $typeinfo['type'],
+        'icon' => $typeinfo['icon'],
+        'oldextension' => $oldextension,
+        'description' => '',
+        'groups' => '',
+        'corestring' => '',
+        'defaulticon' => 0
+    );
+    if (!empty($typeinfo['customdescription'])) {
+        $formdata['description'] = $typeinfo['customdescription'];
+    }
+    if (!empty($typeinfo['groups'])) {
+        $formdata['groups'] = implode(', ', $typeinfo['groups']);
+    }
+    if (!empty($typeinfo['string'])) {
+        $formdata['corestring'] = $typeinfo['string'];
+    }
+    if (!empty($typeinfo['defaulticon'])) {
+        $formdata['defaulticon'] = 1;
+    }
+
+    $mform->set_data($formdata);
+    $title = get_string('editfiletypes', 'tool_filetypes');
+}
+
+$backurl = new \moodle_url('/admin/tool/filetypes/index.php');
+if ($mform->is_cancelled()) {
+    redirect($backurl);
+} else if ($data = $mform->get_data()) {
+    // Convert the groups value back into an array.
+    $data->groups = trim($data->groups);
+    if ($data->groups) {
+        $data->groups = preg_split('~,\s*~', $data->groups);
+    } else {
+        $data->groups = array();
+    }
+    if (empty($data->defaulticon)) {
+        $data->defaulticon = 0;
+    }
+    if (empty($data->corestring)) {
+        $data->corestring = '';
+    }
+    if (empty($data->description)) {
+        $data->description = '';
+    }
+    if ($data->oldextension) {
+        // Update an existing file type.
+        core_filetypes::update_type($data->oldextension, $data->extension, $data->mimetype, $data->icon,
+            $data->groups, $data->corestring, $data->description, (bool)$data->defaulticon);
+    } else {
+        // Add a new file type entry.
+        core_filetypes::add_type($data->extension, $data->mimetype, $data->icon,
+            $data->groups, $data->corestring, $data->description, (bool)$data->defaulticon);
+    }
+    redirect($backurl);
+}
+
+// Page settings.
+$context = context_system::instance();
+$PAGE->set_url(new \moodle_url('/admin/tool/filetypes/edit.php', array('oldextension' => $oldextension)));
+$PAGE->navbar->add($oldextension ? s($oldextension) : $title);
+$PAGE->set_context($context);
+$PAGE->set_pagelayout('admin');
+$PAGE->set_title($SITE->fullname. ': ' . $title);
+
+// Display the page.
+echo $OUTPUT->header();
+$mform->display();
+echo $OUTPUT->footer();
diff --git a/admin/tool/filetypes/edit_form.php b/admin/tool/filetypes/edit_form.php
new file mode 100644
index 00000000000..5d16177212f
--- /dev/null
+++ b/admin/tool/filetypes/edit_form.php
@@ -0,0 +1,115 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Customised file types editing form.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require_once($CFG->dirroot . '/lib/formslib.php');
+
+/**
+ * Form for adding a new custom file type or updating an existing custom file type.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class tool_filetypes_form extends moodleform {
+
+    public function definition() {
+        global $CFG;
+        $mform = $this->_form;
+        $oldextension = $this->_customdata['oldextension'];
+
+        $mform->addElement('text', 'extension', get_string('extension', 'tool_filetypes'));
+        $mform->setType('extension', PARAM_ALPHANUMEXT);
+        $mform->addRule('extension', null, 'required', null, 'client');
+        $mform->addHelpButton('extension', 'extension', 'tool_filetypes');
+
+        $mform->addElement('text', 'mimetype',  get_string('mimetype', 'tool_filetypes'));
+        $mform->setType('mimetype', PARAM_RAW);
+        $mform->addRule('mimetype', null, 'required', null, 'client');
+        $mform->addHelpButton('mimetype', 'mimetype', 'tool_filetypes');
+
+        $fileicons = \tool_filetypes\utils::get_file_icons();
+        $mform->addElement('select', 'icon',
+                get_string('icon', 'tool_filetypes'), $fileicons);
+        $mform->addHelpButton('icon', 'icon', 'tool_filetypes');
+
+        $mform->addElement('text', 'groups',  get_string('groups', 'tool_filetypes'));
+        $mform->setType('groups', PARAM_RAW);
+        $mform->addHelpButton('groups', 'groups', 'tool_filetypes');
+
+        $mform->addElement('select', 'descriptiontype', get_string('descriptiontype', 'tool_filetypes'),
+                array('' => get_string('descriptiontype_default', 'tool_filetypes'),
+                'custom' => get_string('descriptiontype_custom', 'tool_filetypes'),
+                'lang' => get_string('descriptiontype_lang', 'tool_filetypes')));
+
+        $mform->addElement('text', 'description',  get_string('description', 'tool_filetypes'));
+        $mform->setType('description', PARAM_TEXT);
+        $mform->addHelpButton('description', 'description', 'tool_filetypes');
+        $mform->disabledIf('description', 'descriptiontype', 'ne', 'custom');
+
+        $mform->addElement('text', 'corestring',  get_string('corestring', 'tool_filetypes'));
+        $mform->setType('corestring', PARAM_ALPHANUMEXT);
+        $mform->addHelpButton('corestring', 'corestring', 'tool_filetypes');
+        $mform->disabledIf('corestring', 'descriptiontype', 'ne', 'lang');
+
+        $mform->addElement('checkbox', 'defaulticon',  get_string('defaulticon', 'tool_filetypes'));
+        $mform->addHelpButton('defaulticon', 'defaulticon', 'tool_filetypes');
+
+        $mform->addElement('hidden', 'oldextension', $oldextension);
+        $mform->setType('oldextension', PARAM_RAW);
+        $this->add_action_buttons(true, get_string('savechanges'));
+    }
+
+    public function set_data($data) {
+        // Set up the description type.
+        if (!empty($data['corestring'])) {
+            $data['descriptiontype'] = 'lang';
+        } else if (!empty($data['description'])) {
+            $data['descriptiontype'] = 'custom';
+        } else {
+            $data['descriptiontype'] = '';
+        }
+
+        // Call parent.
+        parent::set_data($data);
+    }
+
+    public function validation($data, $files) {
+        $errors = parent::validation($data, $files);
+
+        // Check the extension isn't already in use.
+        $oldextension = $data['oldextension'];
+        $extension = trim($data['extension']);
+        if (\tool_filetypes\utils::is_extension_invalid($extension, $oldextension)) {
+            $errors['extension'] = get_string('error_extension', 'tool_filetypes', $extension);
+        }
+
+        // Check the 'default icon' setting doesn't conflict with an existing one.
+        if (!empty($data['defaulticon']) && !\tool_filetypes\utils::is_defaulticon_allowed(
+                $data['mimetype'], $oldextension)) {
+            $errors['defaulticon'] = get_string('error_defaulticon', 'tool_filetypes', $extension);
+        }
+
+        return $errors;
+    }
+}
diff --git a/admin/tool/filetypes/index.php b/admin/tool/filetypes/index.php
new file mode 100644
index 00000000000..6ac20dcd682
--- /dev/null
+++ b/admin/tool/filetypes/index.php
@@ -0,0 +1,48 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Display the custom file type settings page.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require(__DIR__ . '/../../../config.php');
+require_once($CFG->libdir . '/adminlib.php');
+
+admin_externalpage_setup('tool_filetypes');
+
+// Page settings.
+$title = get_string('pluginname', 'tool_filetypes');
+
+$context = context_system::instance();
+$PAGE->set_url(new \moodle_url('/admin/tool/filetypes/index.php'));
+$PAGE->set_context($context);
+$PAGE->set_pagelayout('admin');
+$PAGE->set_title($SITE->fullname. ': ' . $title);
+
+$renderer = $PAGE->get_renderer('tool_filetypes');
+
+// Is it restricted because set in config.php?
+$restricted = array_key_exists('customfiletypes', $CFG->config_php_settings);
+
+// Display the page.
+echo $renderer->header();
+echo $renderer->edit_table(get_mimetypes_array(), core_filetypes::get_deleted_types(),
+        $restricted);
+echo $renderer->footer();
diff --git a/admin/tool/filetypes/lang/en/tool_filetypes.php b/admin/tool/filetypes/lang/en/tool_filetypes.php
new file mode 100644
index 00000000000..2640b44f7d3
--- /dev/null
+++ b/admin/tool/filetypes/lang/en/tool_filetypes.php
@@ -0,0 +1,69 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Strings for custom file types.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+$string['addfiletypes'] = 'Add a new file type';
+$string['corestring'] = 'Alternative language string';
+$string['corestring_help'] = 'This setting can be used to select a different language string from the core mimetypes.php language file. Generally it should be left blank. For custom types, use the description field.';
+$string['defaulticon'] = 'Default icon for MIME type';
+$string['defaulticon_help'] = 'If there are multiple file extensions with the same MIME type, select this option for one of the extensions so that its icon will be used when determining an icon from the MIME type.';
+$string['delete_confirmation'] = 'Are you absolutely sure you want to remove <strong>.{$a}</strong>?';
+$string['deletea'] = 'Delete {$a}';
+$string['deletefiletypes'] = 'Delete a file type';
+$string['description'] = 'Custom description';
+$string['description_help'] = 'Simple file type description, e.g. &lsquo;Kindle ebook&rsquo;. If your site supports multiple languages and uses the multi-language filter, you can enter multi-language tags in this field to supply a description in different languages.';
+$string['descriptiontype'] = 'Description type';
+$string['descriptiontype_help'] = 'There are three possible ways to specify a description.
+
+* Default behaviour uses the MIME type. If there is a language string in mimetypes.php corresponding to that MIME type, it will be used; otherwise the MIME type itself will be displayed to users.
+* You can specify a custom description on this form.
+* You can specify the name of a languge string in mimetypes.php to use instead of the MIME type.';
+$string['descriptiontype_default'] = 'Default (MIME type or corresponding language string if available)';
+$string['descriptiontype_custom'] = 'Custom description specified in this form';
+$string['descriptiontype_lang'] = 'Alternative language string (from mimetypes.php)';
+$string['displaydescription'] = 'Description';
+$string['editfiletypes'] = 'Edit an existing file type';
+$string['emptylist'] = 'There are no file types defined.';
+$string['error_addentry'] = 'The file type extension, description,  MIME type, and icon must not contain line feed and semicolon characters.';
+$string['error_defaulticon'] = 'Another file extension with the same MIME type is already marked as the default icon.';
+$string['error_extension'] = 'The file type extension <strong>{$a}</strong> already exists or is invalid. File extensions must be unique and must not contain special characters.';
+$string['error_notfound'] = 'The file type with extension {$a} cannot be found.';
+$string['extension'] = 'Extension';
+$string['extension_help'] = 'File name extension without the dot, e.g. &lsquo;mobi&rsquo;';
+$string['groups'] = 'Type groups';
+$string['groups_help'] = 'Optional list of file type groups that this type belongs to. These are generic categories such as &lsquo;document&rsquo; and &lsquo;image&rsquo;.';
+$string['icon'] = 'File icon';
+$string['icon_help'] = 'Icon filename.
+
+The list of icons is taken from the /pix/f directory inside your Moodle installation. You can add custom icons to this folder if required.';
+$string['mimetype'] = 'MIME type';
+$string['mimetype_help'] = 'MIME type associated with this file type, e.g. &lsquo;application/x-mobipocket-ebook&rsquo;';
+$string['pluginname'] = 'File types';
+$string['revert'] = 'Restore {$a} to Moodle defaults';
+$string['revert_confirmation'] = 'Are you sure you want to restore <strong>.{$a}</strong> to Moodle defaults, discarding your changes?';
+$string['revertfiletype'] = 'Restore a file type';
+$string['source'] = 'Type';
+$string['source_custom'] = 'Custom';
+$string['source_deleted'] = 'Deleted';
+$string['source_modified'] = 'Modified';
+$string['source_standard'] = 'Standard';
